#pragma once
#include "stdafx.h"

class CZipFilter : public VFS_Filter
{
public:
	// Constructor / Destructor.
	CZipFilter()
	{}
	virtual ~CZipFilter()
	{}

	// Encoding / Decoding Procedures.
	VFS_BOOL Encode( VFS_FilterReadProc Reader, VFS_FilterWriteProc Writer, const VFS_EntityInfo& DecodedInfo ) const;
	VFS_BOOL Decode( VFS_FilterReadProc Reader, VFS_FilterWriteProc Writer, const VFS_EntityInfo& EncodedInfo ) const;

	// Filter Configuration Data Management.
	VFS_BOOL LoadConfigData( VFS_FilterReadProc Reader );
	VFS_BOOL SaveConfigData( VFS_FilterWriteProc Writer ) const;
	VFS_DWORD GetConfigDataSize() const;

	// Information.
	VFS_PCSTR GetName() const
	{ return VFS_TEXT( "Z-Lib Filter" ); }
	VFS_PCSTR GetDescription() const
	{ return VFS_TEXT( "A Compression Filter using the known Z-Lib Library" ); }
};

extern CZipFilter g_ZipFilter;